use crate::DbPool;
use crate::api::ClientVersion;
use crate::providers::Provider;
use crate::status::*;
use crate::util::cache::VideoCache;
use crate::util::time::parse_time_to_seconds;
use crate::videos::{ServerOptions, VideoItem};
use async_trait::async_trait;
use error_chain::error_chain;
use htmlentity::entity::{ICodedDataTrait, decode};
use std::vec;

error_chain! {
    foreign_links {
        Io(std::io::Error);
        HttpRequest(wreq::Error);
    }
}

pub const CHANNEL_METADATA: crate::providers::ProviderChannelMetadata =
    crate::providers::ProviderChannelMetadata {
        group_id: "mainstream-tube",
        tags: &["tube", "mainstream"],
    };

#[derive(Debug, Clone)]
pub struct PornxpProvider {
    url: String,
}
impl PornxpProvider {
    pub fn new() -> Self {
        let provider = PornxpProvider {
            url: "https://pornxp.ph".to_string(),
        };
        provider
    }

    fn build_channel(&self, clientversion: ClientVersion) -> Channel {
        let _ = clientversion;
        Channel {
            id: "pornxp".to_string(),
            name: "PornXP".to_string(),
            description: "For Those Who Know The Difference".to_string(),
            premium: false,
            favicon: "https://www.google.com/s2/favicons?sz=64&domain=pornxp.ph".to_string(),
            status: "active".to_string(),
            categories: vec![],
            options: vec![
                ChannelOption {
                    id: "sort".to_string(),
                    title: "Sort".to_string(),
                    description: "Sort the Videos".to_string(),
                    systemImage: "list.number".to_string(),
                    colorName: "blue".to_string(),
                    options: vec![
                        FilterOption {
                            id: "new".into(),
                            title: "New".into(),
                        },
                        FilterOption {
                            id: "best".into(),
                            title: "Best".into(),
                        },
                    ],
                    multiSelect: false,
                },
            ],
            nsfw: true,
            cacheDuration: None,
            ytdlpCommand: Some("yt-dlp --impersonate chrome-120".to_string())
        }
    }

    async fn get(
        &self,
        cache: VideoCache,
        page: u8,
        sort: &str,
        options: ServerOptions,
    ) -> Result<Vec<VideoItem>> {
        let sort_string: String = match sort {
            "best" => "best".to_string(),
            _ => "new".to_string(),
        };
        let video_url = format!(
            "{}/{}?page={}",
            self.url, sort_string, page
        );
        let old_items = match cache.get(&video_url) {
            Some((time, items)) => {
                if time.elapsed().unwrap_or_default().as_secs() < 60 * 5 {
                    return Ok(items.clone());
                } else {
                    items.clone()
                }
            }
            None => {
                vec![]
            }
        };

        let mut requester = options.requester.clone().unwrap();
        let text = requester.get(&video_url, None).await.unwrap();
        let video_items: Vec<VideoItem> = self.get_video_items_from_html(text.clone());
        if !video_items.is_empty() {
            cache.remove(&video_url);
            cache.insert(video_url.clone(), video_items.clone());
        } else {
            return Ok(old_items);
        }
        Ok(video_items)
    }

    async fn query(
        &self,
        cache: VideoCache,
        page: u8,
        query: &str,
        sort: &str,
        options: ServerOptions,
    ) -> Result<Vec<VideoItem>> {
        let search_string = query.to_string().to_lowercase().trim().to_string();
        
        let sort_string: String = match sort {
            "best" => "".to_string(),
            _ => "&sort=new".to_string(),
        };
        let video_url = format!(
            "{}/tags/{}?page={}{}",
            self.url, search_string, page, sort_string
        );
        // Check our Video Cache. If the result is younger than 1 hour, we return it.
        let old_items = match cache.get(&video_url) {
            Some((time, items)) => {
                if time.elapsed().unwrap_or_default().as_secs() < 60 * 5 {
                    return Ok(items.clone());
                } else {
                    let _ = cache.check().await;
                    return Ok(items.clone());
                }
            }
            None => {
                vec![]
            }
        };

        let mut requester = options.requester.clone().unwrap();

        let text = requester.get(&video_url, None).await.unwrap();
        let video_items: Vec<VideoItem> = self.get_video_items_from_html(text.clone());
        if !video_items.is_empty() {
            cache.remove(&video_url);
            cache.insert(video_url.clone(), video_items.clone());
        } else {
            return Ok(old_items);
        }
        Ok(video_items)
    }

    fn get_video_items_from_html(&self, html: String) -> Vec<VideoItem> {
        if html.is_empty() {
            println!("HTML is empty");
            return vec![];
        }
        let mut items: Vec<VideoItem> = Vec::new();
        let raw_videos = html.split("id=\"pages\"").collect::<Vec<&str>>()[0]
            .split("<div id=\"content\"")
            .collect::<Vec<&str>>()[1]
            .split("<div class=\"item_cont\">")
            .collect::<Vec<&str>>()[1..]
            .to_vec();
        for video_segment in &raw_videos {
            // let vid = video_segment.split("\n").collect::<Vec<&str>>();
            // for (index, line) in vid.iter().enumerate() {
            //     println!("Line {}: {}", index, line);
            // }
            let video_url: String = format!("{}{}", self.url, video_segment.split("<a href=\"").collect::<Vec<&str>>()[1]
                .split("\"")
                .collect::<Vec<&str>>()[0]
                .to_string());
            let mut title = video_segment
                .split("<div class=\"item_title\">")
                .collect::<Vec<&str>>()[1]
                .split("<")
                .collect::<Vec<&str>>()[0]
                .trim()
                .to_string();
            // html decode
            title = decode(title.as_bytes()).to_string().unwrap_or(title);
            let id = video_url.split("/").collect::<Vec<&str>>()[4].to_string();

            let thumb = match video_segment.contains("<img class=\"item_img lazy\""){
                true => format!("{}{}", self.url,video_segment.split("<img ").collect::<Vec<&str>>()[1]
                .split("data-src=\"").collect::<Vec<&str>>()[1]
                .split("\"")
                .collect::<Vec<&str>>()[0]
                .to_string()),
                false => format!("{}{}", self.url, video_segment.split("<img ").collect::<Vec<&str>>()[1]
                .split("src=\"").collect::<Vec<&str>>()[1]
                .split("\"")
                .collect::<Vec<&str>>()[0]
                .to_string()),};
            let raw_duration = video_segment
                .split("<div class=\"item_dur\">")
                .collect::<Vec<&str>>()[1]
                .split("<")
                .collect::<Vec<&str>>()[0]
                .to_string();
            let duration = parse_time_to_seconds(raw_duration.as_str()).unwrap_or(0) as u32;

            let preview = format!("https:{}",video_segment
                .split("data-preview=\"")
                .collect::<Vec<&str>>()[1]
                .split("\"")
                .collect::<Vec<&str>>()[0]
                .to_string());
            let tags = video_segment.split("<div class=\"item_tags\">").collect::<Vec<&str>>()[1]
                .split("</div>")
                .collect::<Vec<&str>>()[0]
                .split("<a href=\"")
                .collect::<Vec<&str>>()[1..]
                .into_iter().map(|s| s.split(">").collect::<Vec<&str>>()[1]
                .split("<")
                .collect::<Vec<&str>>()[0].to_string()).collect::<Vec<String>>();
            let video_item = VideoItem::new(
                id,
                title,
                video_url.to_string(),
                "pornxpme".to_string(),
                thumb,
                duration,
            )
            .tags(tags)
            .preview(preview);
            items.push(video_item);
        }
        return items;
    }
}

#[async_trait]
impl Provider for PornxpProvider {
    async fn get_videos(
        &self,
        cache: VideoCache,
        pool: DbPool,
        sort: String,
        query: Option<String>,
        page: String,
        per_page: String,
        options: ServerOptions,
    ) -> Vec<VideoItem> {
        let _ = per_page;
        let _ = pool;
        let videos: std::result::Result<Vec<VideoItem>, Error> = match query {
            Some(q) => {
                self.query(cache, page.parse::<u8>().unwrap_or(1), &q, &sort, options)
                    .await
            }
            None => {
                self.get(cache, page.parse::<u8>().unwrap_or(1), &sort, options)
                    .await
            }
        };
        match videos {
            Ok(v) => v,
            Err(e) => {
                println!("Error fetching videos: {}", e);
                vec![]
            }
        }
    }
    fn get_channel(&self, clientversion: ClientVersion) -> Option<crate::status::Channel> {
        Some(self.build_channel(clientversion))
    }
}
